#include <PalmOS.h>
#include <CatooCraft/FrmHelper.h>
#include <CatooCraft/NumberFormat.h>
#include "MileageRsc.h"
#include "Mileage.h"
#include "Record.h"
#include "PrefsForm.h"

using namespace CatooCraftLibrary;

UInt16 PrefsForm::DoModal() {
   FormPtr frm = ::FrmInitForm(IdPreferencesForm);
   Database *db = Mileage::GetDatabase();

   Frm::SetupPopupList(frm, IdDecimalPlacesPopTrigger, IdDecimalPlacesList, NumberFormat::GetDecimalPlaces());
   Frm::SetupPopupList(frm, IdDistanceUnitPopTrigger, IdDistanceUnitList, Record::GetDistanceUnitType());
   Frm::SetupPopupList(frm, IdAmountUnitPopTrigger, IdAmountUnitList, Record::GetAmountUnitType());
   Frm::SetupPopupList(frm, IdSortByPopTrigger, IdSortByList, db->getSortType());
   Frm::SetValue(frm, IdAutoCompleteCheckbox, VendorHistory::IsAutoComplete());
   UInt16 hitButton = ::FrmDoDialog(frm);
   if (hitButton == IdOKButton) {
	  NumberFormat::SetDecimalPlaces((UInt8)Frm::GetLstSelection(frm, IdDecimalPlacesList));
	  Record::SetDistanceUnitType((Record::DistanceUnitType)Frm::GetLstSelection(frm, IdDistanceUnitList));
	  Record::SetAmountUnitType((Record::AmountUnitType)Frm::GetLstSelection(frm, IdAmountUnitList));
	  db->setSortType((Database::SortType)Frm::GetLstSelection(frm, IdSortByList));
	  db->quickSort();
	  VendorHistory::SetAutoCompleteFlag(Frm::GetValue(frm, IdAutoCompleteCheckbox));
   }
   ::FrmDeleteForm(frm);
   return hitButton;
}
