#include "VendorHistory.h"

Boolean VendorHistory::_IsAutoComplete = true;

Int16 VendorHistory::find(Char *vendor) {
   for (Int16 i = 0; i < _count; i++) {
	  if (::StrCompare(_names[i], vendor) == 0)
		 return i;
   }
   return -1;
}

VendorHistory::VendorHistory() : _count(0) {
   for (Int16 i = 0; i < 10; i++) {
	  _names[i] = NULL;
   }
}

VendorHistory::~VendorHistory() {
   for (Int16 i = 0; i < _count; i++) {
	  ::MemPtrFree(_names[i]);
   }
}

void VendorHistory::setup(Char* strings, Int16 count) {
   _count = count;
   Char * p = strings;
   for (Int16 i = 0; i < 10; i++) {
	  if (i < _count) {
		 Int16 l = ::StrLen(p) + 1;
		 _names[i] = (Char *)::MemPtrNew(l);
		 ::StrCopy(_names[i], p);
		 p += l;
		 _uniqueIds[i] = *(p++);
		 _uniqueIds[i] <<= 8;
		 _uniqueIds[i] = *(p++);
		 _uniqueIds[i] <<= 8;
		 _uniqueIds[i] = *(p++);
		 _uniqueIds[i] <<= 8;
		 _uniqueIds[i] = *(p++);
	  } else {
		 _names[i] = NULL;
	  }
   }
}

void VendorHistory::push(Char *vendor, UInt32 uniqueId) {
   Int16 c;
   Int16 found = find(vendor);
   if (found != -1) {
	  c = found;
   } else {
	  if (_count < 10)
		 _count++;
	  c = _count - 1;
   }
   Char *last = _names[c];
   for (Int16 i = c; i > 0; i--) {
	  _names[i] = _names[i-1];
	  _uniqueIds[i] = _uniqueIds[i-1];
   }
   _names[0] = last;
   _uniqueIds[0] = uniqueId;
   if (found == -1) {
	  if (_names[0] != NULL)
		 ::MemPtrFree(_names[0]);
	  _names[0] = (Char *)::MemPtrNew(::StrLen(vendor) + 1);
	  ::StrCopy(_names[0], vendor);
   }
}

Char* VendorHistory::operator[](Int16 i) {
   return _names[i];
}

UInt32 VendorHistory::getUniqueId(Int16 i) {
   return _uniqueIds[i];
}

Int16 VendorHistory::size() {
   Int16 size = 0;
   for (Int16 i = 0; i < _count; i++) {
	  size += ::StrLen(_names[i]) + 1 + sizeof(UInt32);
   }
   return size;
}

Char* VendorHistory::pack(Char *strings) {
   Char *p = strings;
   for (Int16 i = 0; i < _count; i++) {
	  ::StrCopy(p, _names[i]);
	  p += ::StrLen(p) + 1;
	  UInt32 uniqueId = _uniqueIds[i];

	  *(p++) = (uniqueId >> (8*3));
	  *(p++) = (uniqueId >> (8*2)) & 0x00ff;
	  *(p++) = (uniqueId >> (8*1)) & 0x00ff;
	  *(p++) = uniqueId & 0x00ff;
   }
   return strings;
}
