#! ruby
# AllTests.cc  test/Makefile XNvgłD
# PalmUnit ɂ UnitTest 쐬Ă prc t@C̃TCY
# 傫Ȃ肷ăNłȂȂꍇ܂D
# ȂƂ͂̃XNvgpĕI UnitTest {悤
# Ă݂ĂD

class SetUpTest
  def initialize
	@objs = Array.new
	@testobjs = Array.new
  end

  def addModule(obj)
	@objs << obj
  end

  def addModuleWithTest(obj)
	@objs << obj
	@testobjs << obj
  end

  def putAllTests
	includeFiles = @testobjs.collect { |obj|
	  '#include "' + obj + 'Test.h"'
	}.join("\n")

	statement = @testobjs.collect { |obj|
	  '   ' + obj + 'Test test' + obj + '("");' + "\n" +
	  '   addTest(test' + obj + '.suite());'
	}.join("\n")

	print <<XXX
#include "AllTests.h"

#{includeFiles}

AllTests::AllTests() : TestSuite("AllTests")
{
#{statement}
}
XXX
  end

  def putMakefile

	objs = @objs.collect { |obj|
	  "../" + obj + ".o"
	}.join(" \\\n	")
    testobjs = @testobjs.collect { |obj|
	  "../" + obj + "Test.o"
	}.join(" \\\n	")
    testobjs = [objs, testobjs].join(" \\\n	")

	print <<XXX
## Makefile for PalmUnit

TARGET = PalmUnit
APPNAME = "PalmUnit"
APPID = "PmUt"
SDK = -palmos3.5

PALMHOME = ../../../Palm
INCLUDES =  -I${PALMHOME}/include
LIBS = ${PALMHOME}/lib/PalmUnit.a ${PALMHOME}/lib/LibCatoo.a

OBJS = \\
	$(TARGET).o \\
	PalmTestResult.o \\
	TestRunner.o \\
	PalmUnitStopWatch.o

TESTOBJS = \\
	#{testobjs} \\
	../AllTests.o

CC = m68k-palmos-gcc

CFLAGS = -Wall -g ${INC_PATH} ${SDK}

PILRC = pilrc
PILRCFLAGS = -L ENGLISH

OBJRES = m68k-palmos-obj-res
NM = m68k-palmos-nm
BUILDPRC = build-prc
PILOTXFER = pilot-xfer

all: $(TARGET).prc

.cc.o:
	$(CC) $(CFLAGS) -c $<

$(TARGET).prc: code0000.$(TARGET).grc code0001.$(TARGET).grc data0000.$(TARGET).grc pref0000.$(TARGET).grc rloc0000.$(TARGET).grc bin.res
	$(BUILDPRC) $(TARGET).prc $(APPNAME) $(APPID) code0001.$(TARGET).grc code0000.$(TARGET).grc data0000.$(TARGET).grc *.bin pref0000.$(TARGET).grc rloc0000.$(TARGET).grc

code0000.$(TARGET).grc: $(TARGET)
	$(OBJRES) $(TARGET)

code0001.$(TARGET).grc: code0000.$(TARGET).grc

data0000.$(TARGET).grc: code0000.$(TARGET).grc

pref0000.$(TARGET).grc: code0000.$(TARGET).grc

rloc0000.$(TARGET).grc: code0000.$(TARGET).grc

bin.res: $(TARGET).rcp $(TARGET)1.bmp $(TARGET)8.bmp
	$(PILRC)  $(PILRCFLAGS) $(TARGET).rcp .
	touch bin.res

$(TARGET): $(OBJS) $(TESTOBJS)
	$(CC) $(CFLAGS) $(OBJS) $(TESTOBJS) -o $(TARGET) ${LIB_PATH} -lCatooCraft -lPalmUnit

send: $(TARGET).prc
	rm -f $(POSEAUTOLOADPATH)/*.prc
	cp $(TARGET).prc $(POSEAUTOLOADPATH)

depend:
	makedepend -Y -I. *.c

clean:
	-rm -f *.[oa] $(TARGET) *.bin bin.res *.grc Makefile.bak

veryclean: clean
	-rm -f $(TARGET).prc pilot.ram pilot.scratch

header:
	touch $(TARGET)Rsc.h
	$(PILRC) -H $(TARGET)Rsc.add $(TARGET).rcp
	cat $(TARGET)Rsc.add >> $(TARGET)Rsc.h
	rm $(TARGET)Rsc.add

rebuild: clean all
XXX
end

end

if __FILE__ == $0
  require 'getopts.rb'

  if getopts("cm", "objs:", "objswithtest:") == nil then
	raise <<XXX 
usage:
  --objs [eXgȂIuWFNg(ex: Receipt)]
  --objswithtest [eXgIuWFNg (ex: Transaction)]
XXX
  end

  objs = $OPT_objs
  objswithtest = $OPT_objswithtest

  setup = SetUpTest.new

  if objs
	objs.split("\s").each {|obj|
	  setup.addModule(obj)
	}
  end

  if objswithtest
	objswithtest.split("\s").each {|obj|
	  setup.addModuleWithTest(obj)
	}
  end

  if $OPT_m
	setup.putMakefile
  end
  if $OPT_c
	setup.putAllTests
  end
end

