#ifndef __PALM_TEST_RESULT_H__
#define __PALM_TEST_RESULT_H__

#include <PalmOS.h>
#include <TestResult.h>
#include "PalmUnitStopWatch.h"

class PalmTestResult : public TestResult {
	  FieldPtr _runs;
	  FieldPtr _failures;
	  FieldPtr _errors;
	  FieldPtr _finished;
	  RectanglePtr _rectangle;
	  int _count;
	  PalmUnitStopWatch _sw;

	  void setNumber(FieldPtr fld, const Int32 value);
	  void setText(FieldPtr fld, const Char *str);

   public:
	  PalmTestResult() : TestResult(),_runs(0),_failures(0),_errors(0),_finished(0),_rectangle(0),_count(0) {}
	  ~PalmTestResult() {}
	  void setRunsField(FieldPtr field) { _runs = field;}
	  void setFailuresField(FieldPtr field) { _failures = field;}
	  void setErrorsField(FieldPtr field) { _errors = field; }
	  void setFinishedField(FieldPtr field) { _finished = field;}
	  void setProgressRectangle(RectanglePtr r) {_rectangle = r;}
	  void setCountTestCases(int count) {_count = count;}
	  void startTest(Test *test);
	  void endTest(Test *test);
	  void addFailure(Test *test, Exception *e);
	  void addError(Test *test, Exception *e);
};

#endif __PALM_TEST_RESULT_H__
