#ifndef __PALM_UNIT_H__
#define __PALM_UNIT_H__

#include <PalmOS.h>
#include "PalmTestResult.h"
#include "TestRunner.h"

class PalmUnit {
   private:
	  static PalmTestResult * _Result;
	  static TestRunner _Runner;
	  static RectangleType _Rectangle;

	  static ControlPtr GetObjectPtr(FormPtr frm, UInt16 objectId);

	  static void DrawTable(void* table, Int16 row, Int16 column, RectanglePtr bounds);
	  static void UpdateTable(FormPtr frm, PalmTestResult * result, UInt16 pos);
	  static void HandleTableSelect(EventPtr e);
	  static Boolean MainFormHandleEvent(EventPtr e);

   public:
	  static UInt16 StartApplication(void);
	  static void StopApplication(void);
	  static void EventLoop(void);
	  static Boolean HandleEvent(EventPtr e);
};

extern "C" {
   UInt32 PilotMain(UInt16 cmd, void *cmdPBP, UInt16 launchFlags);
}

#endif __PALM_UNIT_H__

