#include <PalmOS.h>
#include "PalmUnitStopWatch.h"

UInt16 PalmUnitStopWatch::_tickPerSecond = (UInt16)SysTicksPerSecond ();

void PalmUnitStopWatch::startStop(UInt32 now)
{
   if (_started)
   {
	  _started = false;
	  _stopTick = now;
   }
   else
   {
	  _started = true;
	  _startTick += now - _stopTick;
   }
}

void StrLToA(char* buf, short place, short value, Boolean zero)
{
   short w;
   int i;

   place--;
   for (i = place; i >= 0; i--)
   {
	  w = value % 10;
	  if (w == 0) {
		 buf[i] = (zero || (i == place))? '0' : ' ';
	  }
	  else{
		 buf[i] = '0' + w;
	  }
	  value /= 10;
   }
}

Char* PalmUnitStopWatch::elapsedTime()
{
   static Char str[9];
   short  w; 
   UInt32 tick = time();

   // 1/100 b
   w = tick % _tickPerSecond;
   StrLToA(&str[7], 2, w, true);
   tick /= _tickPerSecond;

   // b
   w = tick % 60;
   StrLToA(&str[0], 6, w, false);
   tick /= 60;

   str[6] = '.';
   str[9] = '\0';
   return str;
}

