#include <PalmOS.h>
#include <TestCase.h>
#include "TestRunner.h"

TestRunner::~TestRunner() {
   for (mappings::iterator it = _mappings.begin ();
		it != _mappings.end ();
		++it) {
	  delete it->second;
   }
}

void TestRunner::run(char *testCase, PalmTestResult *result) {
   if (testCase == "") return;

   for (mappings::iterator it = _mappings.begin ();
		it != _mappings.end ();
		++it) {
	  if (::StrCompare((*it).first, testCase) == 0)
	  {
		 run ((*it).second, result);
	  }
   }
}

void TestRunner::run(Test *test, PalmTestResult *result) {
   result->setCountTestCases(test->countTestCases());
   test->run(result);
}
