#ifndef __TEST_RUNNER_H__
#define __TEST_RUNNER_H__

#include <Test.h>
#include <vector.h>
#include <pair.h>

#include "PalmTestResult.h"

typedef pair<char *, Test *>           mapping;
typedef vector<pair<char *, Test *> >   mappings;

class TestRunner {
   protected:
	  vector<pair<char *,Test *> > _mappings;

   public:
	  TestRunner() {}
	  ~TestRunner();
	  void addTest(char *name, Test *test) {
		 mapping m(name, test);
		 _mappings.push_back (m);
	  }
	  void run(char *name, PalmTestResult *result);
	  void run(Test *t, PalmTestResult *result);
	  mappings& tests() {return _mappings;}
};

#endif __TEST_RUNNER_H__
